<?php
/**
 * @package    Joomla.UnitTest
 *
 * @copyright  Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license    GNU General Public License version 2 or later; see LICENSE
 */

@include_once 'Cache/Lite.php';

/**
 * Test class for JCacheStorageCachelite.
 * Generated by PHPUnit on 2011-10-26 at 19:41:40.
 *
 * @package     Joomla.UnitTest
 * @subpackage  Cache
 * @since       11.1
 */
class JCacheStorageCacheliteTest extends PHPUnit_Framework_TestCase
{
	/**
	 * @var    JCacheStorageCachelite
	 */
	protected $object;

	/**
	 * @var    boolean
	 */
	protected $extensionAvailable;

	/**
	 * Sets up the fixture, for example, opens a network connection.
	 * This method is called before a test is executed.
	 *
	 * @return void
	 */
	protected function setUp()
	{
		parent::setUp();

		$this->extensionAvailable = class_exists('Cache_Lite');

		if ($this->extensionAvailable)
		{
			$options = array(
				'cachebase' => JPATH_TESTS . '/tmp',
			    'caching'   => true
			);

			$this->object = JCacheStorage::getInstance('cachelite', $options);
		}
		else
		{
			$this->markTestSkipped('This caching method is not supported on this system.');
		}
	}

	/**
	 * Testing isSupported().
	 *
	 * @return  void
	 */
	public function testIsSupported()
	{
		$this->assertEquals(
			$this->extensionAvailable,
			$this->object->isSupported(),
			'Claims Cache_Lite is not loaded.'
		);
	}
}
