<?php
/**
 * @package    Joomla.UnitTest
 *
 * @copyright  Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license    GNU General Public License version 2 or later; see LICENSE
 */

/**
 * Test class for JCacheStorageWincache.
 * Generated by PHPUnit on 2011-10-26 at 19:41:46.
 *
 * @package     Joomla.UnitTest
 * @subpackage  Cache
 * @since       11.1
 */
class JCacheStorageWincacheTest extends PHPUnit_Framework_TestCase
{
	/**
	 * @var    JCacheStorageWincache
	 */
	protected $object;

	/**
	 * @var    boolean
	 */
	protected $extensionAvailable;

	/**
	 * Sets up the fixture, for example, opens a network connection.
	 * This method is called before a test is executed.
	 *
	 * @return  void
	 */
	protected function setUp()
	{
		parent::setUp();

		$this->extensionAvailable = extension_loaded('wincache') && function_exists('wincache_ucache_get') && !strcmp(ini_get('wincache.ucenabled'), '1');

		if ($this->extensionAvailable)
		{
			$this->object = JCacheStorage::getInstance('wincache');
		}
		else
		{
			$this->markTestSkipped('This caching method is not supported on this system.');
		}
	}

	/**
	 * Testing isSupported().
	 *
	 * @return  void
	 */
	public function testIsSupported()
	{
		$this->assertEquals(
			$this->extensionAvailable,
			$this->object->isSupported(),
			'Claims Wincache is not loaded.'
		);
	}

	/**
	 * Testing lock().
	 *
	 * @return  void
	 */
	public function testLock()
	{
		$this->assertFalse(
			$this->object->lock(),
			'Should return default false'
		);
	}

	/**
	 * Testing unlock().
	 *
	 * @return  void
	 */
	public function testUnlock()
	{
		$this->assertFalse(
			$this->object->unlock(),
			'Should return default false'
		);
	}
}
